%find connections in the graph
function [Inc,edge] = edges(fin,Bnode,Inode,r,w)
%assume nodes already ordered

[M,N] = size(fin);

bn = length(Bnode);
in = length(Inode);
node = [Bnode Inode];
nn = length(node);

disp('looking for edges...');

for k = 1:length(node)
   flag = zeros(M,N);
   f = fin;
   flag(node(k).i-2*r:node(k).i+2*r,node(k).j-2*r:node(k).j+2*r) = 1;
   f(node(k).i-2*r:node(k).i+2*r,node(k).j-2*r:node(k).j+2*r) = 1;
   act = f; %active
   p = find(f==1);
   
   step = 0;
   numch = 1;
   while (step < max(M,N)/(2*w) & numch > 0)
      temp = flag;
      
      %one step of diffusion
      for q = 1:length(p)
      	j = floor((p(q)-1)/M)+1; %column
   		i = p(q) - M*(j-1); %row   
         if (act(p(q)) == 1)
            flag(p(q)) = (mean(mean( temp(i-2*w:i+2*w,j-2*w:j+2*w) )) > 0);
         end
      end
      step = step + 1;
      
      diff(step).a = find( (flag(p)-temp(p)) > 0 );
      numch = length(diff(step).a);
      
      %check node intersection
      for l = 1:length(diff(step).a)
         index = p(diff(step).a(l));
         j = floor((index-1)/M)+1; %column
         i = index - M*(j-1); %row 
         if (act(i,j))
            
            dist2 = zeros(length(node),1);
            for o = 1:length(dist2)
               if (o==k) %starting node
                  dist2(o) = M*N;
               else                  
                  dist2(o) = (i-node(o).i)^2 + (j-node(o).j)^2;
               end               
            end
            [md, Imd] = min(dist2);
            
            if (md < 16*w*w) %if close to node
               
               %set inactive
               if (Imd <= bn)
                  act(node(Imd).i-4*r:node(Imd).i+4*r,node(Imd).j-4*r:node(Imd).j+4*r) = 0;
               else
                  act(node(Imd).i-8*w:node(Imd).i+8*w,node(Imd).j-8*w:node(Imd).j+8*w) = 0;
               end       
               
               %estimate midpoint
               mpi = floor((1/2)*(node(k).i + node(Imd).i));
               mpj = floor((1/2)*(node(k).j + node(Imd).j));
               D2 = zeros(length(diff(ceil(step/2)).a),1);
               for  o = 1:length(D2)
                  ind = p(diff(ceil(step/2)).a(o));
                  j = floor((ind-1)/M)+1; %column
         		   i = ind - M*(j-1); %row 
                  D2(o) = (mpi - i)^2 + (mpj - j)^2;
               end
               [mD, ImD] = min(D2);
               
               Inc(k,Imd(1)) = p(diff(ceil(step/2)).a(ImD(1))); %store in inc matrix
               %Inc(k,Imd(1)) = M*(mpj-1) + mpi; %to use exact midpoint instead
               
            end
            
         end         
      end
   end
end

%get the edges
ec = 1;
for i = 1:length(node)
   for j = i+1:length(node)
      if (Inc(i,j) ~= 0 & Inc(j,i)~=0 )
         mind = max(Inc(i,j),Inc(j,i));
         edge(ec).j = j;
         edge(ec).i = i;
         edge(ec).mind = mind;
         edge(ec).mpj = floor((mind-1)/M)+1;
         edge(ec).mpi = mind - M*(edge(ec).mpj-1);
         ec = ec + 1;
      end
   end
end

%better have some edges
if (length(edge) == 0)
   disp('um, no edges?');
   return;
end

%order the edges
clear ind;
for k = 1:length(edge)
   ind(k) = edge(k).mind;
end
[sind, Isind] = sort(ind);
for k = 1:length(edge)
   oedge(k) = edge(Isind(k));
end
edge = oedge;

%visualization
figure(42)
for (t = 1:length(edge))
   hold on
   text(edge(t).mpj,edge(t).mpi,['e_{' num2str(t) '}'],'HorizontalAlignment','center',...
      'FontWeight','bold','color',[0 0 1]);
end

%kept only edges detected both ways
Inc = (Inc & Inc');


         
            
                  
      
      
      